# Laskutin

Laskutin on yksinkertainen massalaskutusohjelma, jolla voidaan sähköpostittaa
ja hallinnoida CSV-tiedostoon kirjattuja laskuja. Laskutin osaa lähettää CSV:n
perusteella laskut ja maksumuistutukset, päivittää maksutilanteen
verkkopankista ladatusta tilitapahtumalistasta ja tulostaa tiivistelmän
maksujen tilanteesta.

Esimerkiksi databileiden osallistumismaksujen ja datatuotetilausten
laskuttamisessa on käytetty Laskutinta.

## Asentaminen

Lisää tämä git-tietovaranto [Guixin kanavalistaan][guix-channels]
seuraavankaltaisella pätkällä:

[guix-channels]: https://guix.gnu.org/manual/devel/en/guix.html#Specifying-Additional-Channels

```lisp
(channel
 (name 'laskutin)
 (url "https://git.datat.fi/ry/laskutin")
 (branch "main")
 (introduction
  (make-channel-introduction
   "3c3f4f7992ed98ebc7fc0d96169d6d2283cb5386"
   (openpgp-fingerprint
    "A0C9 1947 734F 076F 5F08 E9FF 257D 284A 2A1D 3A32"))))
```

Tämän jälkeen Laskutin on saatavilla `laskutin`-nimisenä pakettina kaikkialla
Guixissa. Voit esimerkiksi ottaa sen käyttöön komentotulkkisessioosi komennolla
`guix shell laskutin`.

## Ajaminen

Yleensä laskuttimen käyttö etenee seuraavasti:

1. Määritä laskut CSV-tiedostoon [mallin](./esimerkki.csv) mukaisesti
2. Aja `laskutin send`
3. Hae verkkopankista CSV-tiedosto tilitapahtumista
4. Aja `laskutin update`
5. Aja `laskutin status`
6. Jos kaikkia laskuja ei ole vielä maksettu, aja `laskutin send --reminders`
   ja palaa kohtaan 3.

Jokaiselle komennolle tarvitsee määrittää oikeat asetukset komentorivillä
annettavilla valitsimilla. Mahdolliset valitsimet voi listata kirjoittamalla
komennon perään `--help`-valitsimen.

## Kehittäminen

Kehitysympäristön saat helposti Guixilla ajamalla komennon [`guix
shell`][guix-shell] tässä hakemistossa. Muutoksia, vikailmoituksia ja
kehitysideoita voi jättää Giteassa tai sähköpostilla osoitteeseen
<saku@laesvuori.fi>. Tarkista, että laskutin kääntyy vielä muutostesi jälkeen
ajamalla komento `guix time-machine -C channels.scm -- build -f guix.scm`.

[guix-shell]: https://guix.gnu.org/manual/devel/en/guix.html#Invoking-guix-shell

## Kopioiminen

Laskutin on [GNU AGPL lisenssin version kolme](COPYING.md), tai valintasi
mukaan minkä tahansa myöhemmän [Free Software Foundationin julkaiseman
version][fsf-agpl], alainen vapaa ohjelma, eli se kunniottaa käyttäjiensä
vapautta päättää itse omasta tietojenkäsittelystään ja auttaa toisiaan.

[fsf-agpl]: https://www.gnu.org/licenses/agpl-3.0.html
